<?php
/**
 * Lucene -  My very own search engine
 * (c) 2012 Stefan Rottensteiner, rottensteiner.stefan@gmx.at
 */

Header('Content-Type: text/plain; charset=utf-8');

/* Flag: Index vorher löschen ?*/
$deleteIndex    = TRUE;
/* Flag: Feeds Importieren ?*/
$importFeeds 	= TRUE;
/* Flag: Bilder Importieren ?*/
$importImages 	= TRUE;

/* INIT */
include_once 'init.php';


if ( luceneHaveImportPIDFile() == TRUE ) {
	echo 'Importer is already working. Please Try again in a minute.' . PHP_EOL;
	die;
}
luceneCreateImportPIDFile();

/* Wernn gewünscht, vorher den gesamten Index löschen */
if ( $deleteIndex) {
	echo 'Deleting Lucene files ...' . PHP_EOL;
	$d = dir($storageDir);
	while (false !== ($entry = $d->read())) {
		if ( $entry[0] == '.' ) continue;
		$entry = $storageDir.'/'.$entry;
		@unLink($entry);
	}
}

/* Lucen Index aufmachen */
$Index = openLuceneIndex($storageDir);

/* Feeds importieren */
if ( $importFeeds ) {
	/* Liste der Feeds, die uns interessieren */
	$feeds = array(
		'http://kurier.at/rss/detail/nachrichten_nachrichten_rss.xml',
		'http://kurier.at/rss/kw_oesterreich_rss.xml',
		'http://www.ots.at/rss/index',
		'http://kurier.at/rss/detail/futurezone_futurezone_rss.xml',
		'http://kurier.at/rss/blog_sexleben_rss.xml',
		'http://kurier.at/rss/horoskop_rss.xml',
		'http://rss.golem.de/rss.php?feed=RSS1.0',
		'http://www.zend.com/de/company/news/press/feed',
		'http://www.oe24.at/xml/rssImage',
		'http://futurezone.at/rss.xml'
	);

	echo 'Reading feeds ... ' . PHP_EOL;
	forEach ( $feeds as $feedURL ) {
		echo '===========================================' . PHP_EOL;
		echo 'Feed-URL   : ' . $feedURL . PHP_EOL;
		$Feed = Zend_Feed_Reader::import( $feedURL  );
		echo 'Title      : ' . $Feed->getTitle() . PHP_EOL;
		echo 'Description: ' . preg_replace('~[\s]+~',' ',$Feed->getDescription()) . PHP_EOL;
		flush();

		forEach ($Feed as $Item) {
			flush();
			echo '------------------------------------------ text/html' . PHP_EOL;
			$itemTitle 	= luceneNormalizeHTMLText($Item->getTitle());
			$itemText 	= luceneNormalizeHTMLText($Item->getDescription());
			$itemContent= luceneNormalizeHTMLText($Item->getContent());
			/* Machnmal steht unter "content" noch was anderes, das wollen wir auch haben */
			if ($itemContent && $itemContent != $itemText)
				$itemText.='. ' . $itemContent;
			$itemLink 	= $Item->getLink();
			/* Es gibt Seiten, die Artikel-IDs in die URLs codiederen ;) */
			$matches = array();
			preg_match('~\/(\d+)\-.*\.php~', $itemLink, $matches );
			@$itemID     = intVal( $matches[1] );

			echo 'Title: ' . $itemTitle . PHP_EOL;
			echo 'Link : ' . $itemLink . PHP_EOL;
			echo 'ID   : ' . $itemID . PHP_EOL;
			echo 'Text : ' . $itemText . PHP_EOL;
            /* Lucene Dcokument erzeugen */
			$Document = new Zend_Search_Lucene_Document();
			/* Lucene Dcokument mit Werten befüllen */
			$Document->addField(Zend_Search_Lucene_Field::text('content-type','text/html', 'UTF-8'));
			$Document->addField(Zend_Search_Lucene_Field::text('title',$itemTitle, 'UTF-8'));
			if ($itemID)
				$Document->addField(Zend_Search_Lucene_Field::text('sourceID',$itemID, 'UTF-8'));
			$Document->addField(Zend_Search_Lucene_Field::text('link',$itemLink, 'UTF-8'));
			$Document->addField(Zend_Search_Lucene_Field::unStored('text',$itemText, 'UTF-8'));
			if (!empty($itemKeyword))
				$Document->addField(Zend_Search_Lucene_Field::unStored('keywords',$itemKeyword, 'UTF-8'));

			/* Lucene Dcokument zum Index hinzufügen  */
			@$Index->addDocument( $Document );
			/* Wenn es Bilder gibt, dann diese auch noch in den Index stopfen */
			@$itemEnclosure = get_object_vars($Item->getEnclosure());
			if (strPos($itemEnclosure['type'],'image/') === 0 ) {
				$itemType = $itemEnclosure['type'];
				$itemLink = $itemEnclosure['url'];

				echo '------------------------------------------ ' . $itemType . PHP_EOL;
				echo 'Title: ' . $itemTitle . PHP_EOL;
				echo 'Link : ' . $itemLink . PHP_EOL;
				echo 'Text : ' . $itemText . PHP_EOL;

				$Document = new Zend_Search_Lucene_Document();
				$Document->addField(Zend_Search_Lucene_Field::text('content-type', $itemType, 'UTF-8'));
				@$Document->addField(Zend_Search_Lucene_Field::text('title', $itemTitle, 'UTF-8'));
				@$Document->addField(Zend_Search_Lucene_Field::text('link', $itemLink, 'UTF-8'));
				@$Document->addField(Zend_Search_Lucene_Field::unStored('text', $itemText, 'UTF-8'));
				@$Index->addDocument( $Document );
			}
		}
	}
}

/* Bilder importieren */
if ($importImages) {
	/* Googles Bildersuche anzapfen: Suche nach "iphone 5" und "Calvin and Hobbes" */
	$sources= array(
		'http://www.google.at/search?q=iphone+5&hl=de&prmd=imvnsu&source=lnms&tbm=isch',
		'http://www.google.at/search?q=Calvin+and+Hobbes&hl=de&prmd=imvnsu&source=lnms&tbm=isch'
	);

	forEach($sources as $source ){
		echo 'Read Google Image Search: ' . $source . PHP_EOL;
		$content 		= file_get_contents( $source );
		$content        = utf8_encode($content);
		$content 		= preg_replace('~[\s]+~misu',' ', $content );
		
		$matches 		= array();
		$subMatches 	= array();
		$continueSearch = true;
		do {
			if ( preg_match_all('~\<td\s+style\="width:25%;word-wrap:break-word"\>(.+)\<\/td\>\s*\<\/div\>~umisU', $content , $matches ) ) {
					forEach( $matches[1] as $index => $subContent ){
						$content    = str_replace($matches[0][$index],'', $content);
						$itemType	= 'image/jpeg';
						$itemTitle	= '';
						$itemLink	= '';
						$itemText	= '';

						if ( preg_match('~imgurl\=(.*)\&amp\;imgrefurl\=~umisU', $subContent, $subMatches) ) {
							$itemLink = $subMatches[1];
						}
						$itemTitle = baseName( $itemLink );
						if ( preg_match('~\<\/a\>(.*)$~umisU', $subContent, $subMatches) ) {
							$itemText = $subMatches[1];
						}
						if ( preg_match('~([a-z]{3,4})$~umisU', $subContent, $subMatches) ) {
							$itemType = 'image/' . $subMatches[1];
							if ($itemType == 'image/jpg') $itemType = 'image/jpeg';
						}
						$itemTitle 	= luceneNormalizeHTMLText( $itemTitle );
						$itemText 	= luceneNormalizeHTMLText( $itemText );
						flush();
						echo '------------------------------------------' . PHP_EOL;
						echo 'Title: ' . $itemTitle . PHP_EOL;
						echo 'Link : ' . $itemLink . PHP_EOL;
						echo 'Text : ' . $itemText . PHP_EOL;

						$Document = new Zend_Search_Lucene_Document();
						$Document->addField(Zend_Search_Lucene_Field::text('content-type', $itemType, 'UTF-8'));
						@$Document->addField(Zend_Search_Lucene_Field::text('title', $itemTitle, 'UTF-8'));
						@$Document->addField(Zend_Search_Lucene_Field::text('link', $itemLink, 'UTF-8'));
						@$Document->addField(Zend_Search_Lucene_Field::unStored('text', $itemText, 'UTF-8'));
						@$Index->addDocument( $Document );
					}
			} else {
				$continueSearch = FALSE;
			}
		}
		while ($continueSearch);
	}
}

echo '=========================================== Finishing import' . PHP_EOL;

echo 'Some sort of "flush"' . PHP_EOL;
/* Flush, bla bla bla */
$Index->commit();
echo 'Optimze ...' . PHP_EOL;
$Index->optimize();

/* Ein paar Stats ausgeben */
$docsTotal = $Index->count();
$docsSearchable = $Index->numDocs();
$docsDeleted = $docsTotal - $docsSearchable;

echo 'Total # of documents : ' . $docsTotal . PHP_EOL;
echo 'Searchable ocuments  : ' . $docsSearchable . PHP_EOL;
echo 'Deleted documents    : ' . $docsDeleted . PHP_EOL;

unset($Index);
echo 'Good Night And Good Luck' . PHP_EOL;

luceneDeleteImportPIDFile();








